def get_sum_p(x, dvs):
    s = 0
    for i in range(n):
        z, a, b = dvs[i + 1]
        if x <= z:
            s += x * a
        else:
            s += (a * z) + b * (x - z)
    return s


def find_close(p, z_vars):
    pred = 0
    for k in z_vars.keys():
        if p < z_vars[k]:
            return pred
        pred = k


def which_to_choose(z_vars, p):
    if p in z_vars.values():
        for k, v in z_vars:
            if p == v:
                return k
    if p < z_vars[all_f]:
        if p % only_a == 0:
            return p // only_a
        return int(p / only_a) + 1
    if p > z_vars[all_s]:
        need_more = p - get_sum_p(all_s, dvs)
        if need_more % only_b == 0:
            return all_s + need_more // only_b
        return all_s + int(need_more / only_b) + 1
    else:
        mi = find_close(p, z_vars)
        x = mi
        while get_sum_p(x, dvs) < p:
            x += 1
        return x


n, p = [int(i) for i in input().split()]
dvs = {}
diff_z = set()
only_a = 0
only_b = 0
for i in range(n):
    z, a, b = [int(j) for j in input().split()]
    dvs[i + 1] = [z, a, b]
    only_a += a
    only_b += b
    diff_z.add(z)
z_vars = {}

for z in sorted(diff_z):
    sum_p = get_sum_p(z, dvs)
    z_vars[z] = sum_p
all_f = min(z_vars.keys())
all_s = max(z_vars.keys())
print(which_to_choose(z_vars, p))
